]> git.madduck.net Git - code/vcsh.git/blob - vcsh

madduck's git repository

Every one of the projects in this repository is available at the canonical URL git://git.madduck.net/madduck/pub/<projectpath> — see each project's metadata for the exact URL.

All patches and comments are welcome. Please squash your changes to logical commits before using git-format-patch and git-send-email to patches@git.madduck.net. If you'd read over the Git project's submission guidelines and adhered to them, I'd be especially grateful.

SSH access, as well as push access can be individually arranged.

If you use my repositories frequently, consider adding the following snippet to ~/.gitconfig and using the third clone URL listed for each project:

[url "git://git.madduck.net/madduck/"]
  insteadOf = madduck:

Do not rely on XDG settings being the defaults
[code/vcsh.git] / vcsh
1 #!/bin/sh
2
3 [ -n "$VCSH_DEBUG" ] && set -x
4
5 SELF=$(basename $0)
6
7 [ -z "$XDG_CONFIG_HOME" ] && XDG_CONFIG_HOME="$HOME/.config"
8 [ -z "$VCSH_BASE" ]       && VCSH_BASE="$XDG_CONFIG_HOME/vcsh/repo.d"
9 for check_directory in "$VCSH_BASE"
10 do
11         if [ ! -d "$check_directory" ]; then
12                 if [ -e "$check_directory" ]; then
13                         echo "$SELF: error: $check_directory exists but is not a directory" >&2
14                         exit 2
15                 else
16                         mkdir -p "$check_directory" || (echo "$SELF: error: could not create $check_directory" >&2; exit 2)
17                 fi
18         fi
19 done
20
21 debug() {
22         [ -n "$VCSH_DEBUG" ] && echo "$SELF: debug: $1"
23 }
24
25 verbose() {
26         if [ -n "$VCSH_DEBUG" ] || [ -n "$VCSH_VERBOSE" ]; then echo "$SELF: verbose: $1"; fi
27 }
28
29 #   use <repo>     Use this repository
30 #
31 #   exit              Exit vcsh mode" >&2
32 help() {
33         echo "usage: $SELF <args>
34
35    help              Display this help
36
37    list              List all repos
38
39    run <repo> \\
40        <command>     Use this repository
41
42    init <repo>       Initialize a new repository
43    clone <remote> \\
44          [<repo>]    Clone from an existing repository
45    seed-gitignore \\
46    <repo>            Seed .gitignore.d/<repo> from git ls-files" >&2
47 }
48
49 use() {
50         verbose "use() begin"
51         REPO_NAME="$1"
52         GIT_DIR="$VCSH_BASE/$REPO_NAME.git"
53
54         if [ ! -d "$GIT_DIR" ]; then
55                 echo E: no repository found for "$REPO_NAME" >&2
56                 return 2
57         fi
58
59         export GIT_DIR
60         export GIT_WORK_TREE="$(git config --get core.worktree)"
61         export VCSH_DIRECTORY="$REPO_NAME"
62         verbose "use() end"
63 }
64
65 init() {
66         verbose "init() begin"
67         [ -e "$GIT_DIR" ] &&
68                 echo "$SELF: fatal: $GIT_DIR exists" &&
69                 return 21
70         export GIT_WORK_TREE="$HOME"
71         mkdir -p "$GIT_WORK_TREE"
72         cd "$GIT_WORK_TREE" ||
73                 (echo "$SELF: fatal: could not enter $GIT_WORK_TREE" &&
74                  exit 20) || exit 20
75         cd "$GIT_WORK_TREE"
76         git init
77         git config core.worktree "$GIT_WORK_TREE"
78         verbose "init() end"
79 }
80
81 leave() {
82         unset GIT_DIR
83         unset GIT_WORK_TREE
84         unset VCSH_DIRECTORY
85 }
86
87 if [ "$1" = 'help' ] || [ "$#" -eq 0 ]; then
88         help
89         [ "$1" = 'help' ]
90         exit $?
91
92 elif [ "$1" = 'list' ]; then
93         verbose "list begin"
94         for i in "$VCSH_BASE"/*.git; do
95                 echo $(basename "$i" .git)
96         done
97         verbose "list end"
98         exit 0
99
100 elif [ "$1" = 'run' ]; then
101         verbose "run begin"
102         use "$2"
103         shift 2
104         "$@"
105         leave
106         verbose "run end"
107         exit 0
108
109 #elif [ "$1" = 'use' ]; then
110 #       verbose "use begin"
111 #       if [ -n "$ZSH_VERSION" ]; then
112 #               if [ -o NO_IGNORE_EOF ]; then
113 #                       export VCSH_NO_IGNORE_EOF=1
114 #                       setopt IGNORE_EOF
115 #               fi
116 #               vcsh_exit() {
117 #                       vcsh exit;
118 #                       zle reset-prompt;
119 #               }
120 #               zle -N vcsh_exit
121 #               bindkey '^d' 'vcsh_exit'
122 #       fi
123 #       use $2
124 #       [ -n "$ZSH_VERSION" ] && [ "$USER" = richih ] && buildPS1
125 #       verbose "use end"
126 #       exit 0
127
128 elif [ "$1" = 'clone' ]; then
129         verbose "clone begin"
130         GIT_REMOTE="$2"
131         REPO_NAME="$3"
132         [ -z "$REPO_NAME" ] && REPO_NAME=$(basename "$GIT_REMOTE" .git)
133         export REPO_NAME
134         export GIT_DIR="$VCSH_BASE/$REPO_NAME.git"
135         init
136
137         git remote add origin "$GIT_REMOTE"
138         git config branch.master.remote origin
139         git config branch.master.merge  refs/heads/master
140         git fetch
141         for object in $(git ls-tree -r origin/master | awk '{print $4}'); do
142                 [ -e "$object" ] &&
143                         echo "$SELF: error: $object exists." &&
144                         VCSH_CONFLICT=1;
145         done
146         [ "$VCSH_CONFLICT" = '1' ] &&
147                 echo "$SELF: fatal: will stop after fetching and not try to merge!\n" &&
148                 echo "  Once this situation has been resolved, run 'vcsh run <foo> git pull' to finish cloning.\n" &&
149                 exit 3
150         git merge origin/master
151 #       vcsh use $REPO_NAME
152         verbose "clone end"
153
154 elif [ "$1" = 'init' ]; then
155         verbose "init begin"
156         [ -z $2 ] && help && echo && echo "$SELF $1: please specify repository to work on" && return 0
157         export REPO_NAME="$2"
158         export GIT_DIR="$VCSH_BASE/$REPO_NAME.git"
159         init
160 #       vcsh use "$REPO_NAME"
161         verbose "init end"
162
163 #elif [ "$1" = 'exit' ]; then
164 #       verbose "exit begin"
165 #       if [ -n "$ZSH_VERSION" ] && [ "$VCSH_NO_IGNORE_EOF" = '1' ]; then
166 #               unset VCSH_NO_IGNORE_EOF
167 #               setopt NO_IGNORE_EOF
168 #       fi
169 #       leave
170 #       [ -n "$ZSH_VERSION" ] && [ "$USER" = richih ] && buildPS1
171 #       verbose "exit end"
172 #       exit 0
173
174 elif [ "$1" = 'seed-gitignore' ]; then
175         verbose "seed-gitignore begin"
176         [ -z $2 ] && help && echo && echo "$SELF $1: please specify repository to work on" && return 0
177         use "$2"
178         files=$(git ls-files)
179         gitignores=$(for file in $(git ls-files); do
180                 while true; do
181                         echo $file; new="${file%/*}"
182                         [ "$file" = "$new" ] && break
183                         file="$new"
184                 done;
185         done | sort -u | sed 's/^/!/')
186         [ -e .gitignore.d/$2 ] &&
187         echo "$SELF: .gitignore.d/$2 exists, moving it to .gitignore.d/$2.bak" &&
188         mv -f .gitignore.d/$2 .gitignore.d/$2.bak
189         echo '*' > .gitignore.d/$2
190         for gitignore in $gitignores; do
191                 echo $gitignore >> .gitignore.d/$2
192         done
193
194 else
195         verbose "defaulting to calling help()"
196         help
197         exit 3
198
199 fi
200